// QueryDlgDlg.cpp : implementation file
//

#include "stdafx.h"
#include "QueryDlg.h"
#include "QueryDlgDlg.h"
#include ".\querydlgdlg.h"
#include "afxinet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CQueryDlgDlg dialog



CQueryDlgDlg::CQueryDlgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CQueryDlgDlg::IDD, pParent)
	, m_strHost(_T(""))
	, m_strOut(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CQueryDlgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_HOST, m_strHost);
	DDX_Text(pDX, IDC_OUT, m_strOut);
}

BEGIN_MESSAGE_MAP(CQueryDlgDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
END_MESSAGE_MAP()


// CQueryDlgDlg message handlers

BOOL CQueryDlgDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CQueryDlgDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CQueryDlgDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CQueryDlgDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CQueryDlgDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	const CString http = "http://";
	UpdateData(TRUE);
	m_strOut = "";
	UpdateData(FALSE);

	TryURL(http + m_strHost);
	TryURL(http + "www." + m_strHost);
	TryFTPSite(m_strHost);
	TryFTPSite("ftp." + m_strHost);

}

void CQueryDlgDlg::TryURL(CString URL)
{
	CInternetSession session;

	m_strOut += "Trying " + URL + "\r\n";
	UpdateData(FALSE);

	CInternetFile* file = NULL;
	try {
		file = (CInternetFile*) session.OpenURL(URL);
		TRACE("http open\n");
	} catch (CInternetException* pEx) {
		file = NULL;
		pEx->Delete();
	}
	if (file) {
		m_strOut += "Connection established. \r\n";
		CString line;
		TRACE("http connected\n");
		for (int i=0; i < 20 && file->ReadString(line); i++) {
			m_strOut += line + "\r\n";
			TRACE("%s\n", line);
		}
		file->Close();
		delete file;
	} else {
		m_strOut += "No server found here. \r\n";
	}
	m_strOut += "-------------------------------\r\n";
	UpdateData(false);
}

void CQueryDlgDlg::TryFTPSite(CString strHost)
{
	CInternetSession session;

	m_strOut += "Trying FTP site " + strHost + "\r\n";
	UpdateData(FALSE);

	CFtpConnection* pConn = NULL;
	try {
		pConn = session.GetFtpConnection(strHost);
	} catch (CInternetException* pEx) {
		pConn = NULL;
		pEx->Delete();
	}
	if (pConn) {
		m_strOut += "Connection established. \r\n";
		CString strLine;
		pConn->GetCurrentDirectory(strLine);
		m_strOut += "default directory is " + strLine + " \r\n";
		pConn->Close();
		delete pConn;

	} else {
		m_strOut += "No server found here. \r\n";
	}
	m_strOut += "-------------------------------\r\n";
	UpdateData(false);
}
